#!/bin/bash

# Software of pdfinfo, pdftk, and convert are used.
# These are included in poppler-utils, pdftk, and imagemagick packages in debian.


if [ $# -lt 1 ]; then
    pdffile="dcl.pdf"
else
    pdffile=$1
fi


if [ -e ./figs-png ]; then
  rm -f ./figs-png/*
else
  mkdir ./figs-png
fi

if [ -e ./figs-pdf ]; then
  rm -f ./figs-pdf/*
else
  mkdir ./figs-pdf
fi


pdfinfo $pdffile > pdfinfo.txt
num=`grep 'Pages' pdfinfo.txt | cut -d':' -f2`

i=1
while test $i -le $num
  do
    if [ $i -lt 10 ]; then
      j=0000"$i"
    elif [ $i -lt 100 ]; then
      j=000"$i"
    elif [ $i -lt 1000 ]; then
      j=00"$i"
    elif [ $i -lt 10000 ]; then
      j=0"$i"
    else
      echo "too large"
    fi
#    echo $j
    pdftk $pdffile cat "$j" output figs-pdf/fig_"$j".pdf
#    pstoimg -density 144 -flip r270 figs-pdf/fig_"$j".pdf -out figs-png/fig_0"$j".png
#    convert -rotate 90 figs-pdf/fig_"$j".pdf figs-png/fig_0"$j".png
    convert figs-pdf/fig_"$j".pdf -rotate 90 \( +clone -alpha opaque -fill white -colorize 100% \) +swap -geometry +0+0 -compose Over -composite -alpha off figs-png/fig_0"$j".png
    i=$(( $i + 1 ))
  done

#ffmpeg -i figs-png/dcl_%06d.png -qscale 0 out.avi
#ffmpeg -i figs-png/dcl_%06d.png -qscale 0 anim.avi
#ffmpeg -r 1 -i figs-png/fig_%06d.png -qscale 0 -vcodec libx264 anim.mp4
ffmpeg -r 1 -i figs-png/fig_%06d.png -qscale 0 -vcodec libx264 -pix_fmt yuv420p anim.mp4
rm pdfinfo.txt
