require "numru/ggraph"
require "./gp_dcpam_const_v1.0"
require "./gp_dcpam_methods_v1.0"
include NumRu

DaysInAYear = DaysOfMonth.sum

if ARGV.size == 3 then
  path   = ARGV[1]
  vname  = ARGV[2]
else
  print "Unexpected number of arguments: ", ARGV.size, "\n"
  exit
end


ncfn = path
url = ncfn + "@" + vname
gphys = GPhys::IO.open_gturl( url )

va_time_in = gphys.coord('time')
na_time_in = va_time_in.val
ntime = na_time_in.size
gphys = gphys.cut('time'=>na_time_in[-DaysInAYear*DataNumOfDay]..na_time_in[-1])
gpout = time_interval_mean( gphys, DataNumOfDay*1 )
na_time_out = gpout.coord('time').val - na_time_in[-DaysInAYear*DataNumOfDay]
replace_axis(
  gpout, "time",
  "time", va_time_in.long_name, va_time_in.units.to_s, na_time_out )

gpout = gpout.mean('lon')


iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i
DCL.gropn(iws)

#DCL.sldiv('y',1,4)
DCL.sgpset('isub', 96)     # control character of subscription: '_' --> '`'
DCL.sgpset('lfull',true)
DCL.uzfact(0.6)            # font size
DCL.sgpset('lclip', true)  # clip graph
DCL.glpset('lmiss',true)   # missing value

#DCL.sgscmn(4)  # blue-cyan-white-yellow-red
#DCL.sgscmn(5)  # gray-scale
#DCL.sgscmn(14) # blue-white-red

#levels = [110,120,130,140,150,160,170,180,190,200,210,220,230,240]
#patterns = [10999,15999,20999,25999,30999,35999,40999,50999,60999,65999,70999,75999,80999,90999,95999]

GGraph.set_axes('ylabelint'=>30)
GGraph.set_fig 'itr'=> 1, 'viewport'=>[0.1,0.9,0.1,0.6], 'window'=>[gpout.coord('time').val[0].ceil,gpout.coord('time').val[-1].ceil,-90,90]

GGraph.tone    gpout, true , 'exchange'=>true,
               'nlev'=>50, 'keep'=>true
#               'min'=>cntmin, 'max'=>cntmax #, 'lev'=>levels, 'pat'=>patterns
#GGraph.contour gpout, false, 'exchange'=>true,
#               'nlev'=>50, 'keep'=>true
##               'min'=>cntmin, 'max'=>cntmax #, 'lev'=>levels
GGraph.color_bar

DCL.grcls
