require "numru/ggraph"
require 'getoptlong'
require "./gp_dcpam_const_v1.0"
require "./gp_dcpam_methods_v1.0"
include NumRu


parser = GetoptLong.new
parser.set_options(
  ['--meantype',                 GetoptLong::REQUIRED_ARGUMENT],
  ['--path_sig_weight',          GetoptLong::REQUIRED_ARGUMENT],
)
begin
  parser.each_option do |name, arg|
    eval "$OPT_#{name.sub(/^--/, '').gsub(/-/, '_')} = '#{arg}'"
#    print name, ":", arg, "\n"
  end
rescue
  exit(1)
end
#
if ARGV.size == 4 then
  path            = ARGV[1]
  vname           = ARGV[2]
  path_ps         = ARGV[3]
else
  print "Unexpected number of arguments: ", ARGV.size, "\n"
  exit
end
#
meantype        = ($OPT_meantype||"year").to_s
path_sig_weight = ($OPT_path_sig_weight||path).to_s


DaysInAYear = DaysOfMonth.sum

ncfn = path
url = ncfn + "@" + vname
gphys = GPhys::IO.open_gturl( url )

ncfn = path_ps
url = ncfn + "@" + "Ps"
gp_ps = GPhys::IO.open_gturl( url )

ncfn = path_sig_weight
url = ncfn + "@" + "sig_weight"
print url, "\n"
gp_sig_weight = GPhys::IO.open_gturl( url )


na_time_in    = gphys.coord('time').val
na_sig_weight = gp_sig_weight.val.reshape!(1,1,gp_sig_weight.val.size)


case meantype
when "year" then
  a_meanwidth = [ DaysInAYear * DataNumOfDay ]
when "month" then
  a_meanwidth = Array.new( DaysOfMonth.size )
  DaysOfMonth.each_with_index do |nDays, index|
    a_meanwidth[index] = nDays * DataNumOfDay
  end
end
nMon = a_meanwidth.length

imax = gphys.coord('lon').val.size
jmax = gphys.coord('lat').val.size
kmax = gphys.coord('sig').val.size
tmax = nMon
na_AveArray = NArrayMiss.float(imax,jmax,tmax)


ts0 = - DaysInAYear * DataNumOfDay
te0 = -1

te  = ts0-1
for iMon in 0..(nMon-1)

  nAve = a_meanwidth[iMon]

  ts = te  + 1
  te = ts  + nAve-1
  te = [te0,te].min

  print "  iMon: ", iMon, ", ts: ", ts, ", te: ", te, "\n"

  tmax_sl = 1000
  for iloop in 0..((te-ts-1)/tmax_sl)
    ts_sl = ts + tmax_sl * iloop
    te_sl = ts_sl + tmax_sl - 1
    te_sl = [te_sl,te].min
#  print iloop, ", ", ts_sl, ", ", te_sl, "\n"

    if iloop == 0 then
      gpout_tmp = gphys[true,true,0,0].copy
      gpout_tmp[true,true] = 0.0
    end

    gpout_tmp = gpout_tmp +
            integrate_vertical(
              gp_sig_weight,
              gp_ps[true,true,ts_sl..te_sl],
              gphys[true,true,true,ts_sl..te_sl] ).sum(2)
  end
  gpout_tmp = gpout_tmp / ( te-ts+1 )

  na_AveArray[true,true,iMon] = gpout_tmp.val[true,true]

end

ax_lon      = gphys.axis('lon')
ax_lat      = gphys.axis('lat')
na_time_out = NArray.sfloat(nMon).indgen(1,1)
va_time     = VArray.new( na_time_out, 
                          {"long_name"=>"time", "units"=>"months"},
                          "time" )
ax_time     = Axis.new.set_pos(va_time)
va_data     = VArray.new( na_AveArray, 
                          {"long_name"=>gphys.long_name,
                           "units"=>gphys.units.to_s},
                          gphys.name )
gpout = GPhys.new( Grid.new(ax_lon,ax_lat,ax_time), va_data )


iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i
DCL.gropn(iws)

#DCL.sldiv('y',1,4)
DCL.sgpset('isub', 96)     # control character of subscription: '_' --> '`'
DCL.sgpset('lfull',true)
DCL.uzfact(0.6)            # font size
DCL.sgpset('lclip', true)  # clip graph
DCL.glpset('lmiss',true)   # missing value

#DCL.sgscmn(4)  # blue-cyan-white-yellow-red
#DCL.sgscmn(5)  # gray-scale
#DCL.sgscmn(14) # blue-white-red

#levels = [110,120,130,140,150,160,170,180,190,200,210,220,230,240]
#patterns = [10999,15999,20999,25999,30999,35999,40999,50999,60999,65999,70999,75999,80999,90999,95999]


#if flag_cntlog then
#  cntmin = nil
#  cntmax = nil
#else
  cntmin = gpout.min
  cntmax = gpout.max
#end
for iMon in 0..(nMon-1)
  GGraph.set_fig 'itr'=> 10, 'viewport'=>[0.1,0.9,0.2,0.6], 'window'=>[0,360,-90,90]
  if PlanetName == "Earth" then
    GGraph.set_map "coast_world"=>true, 'grid'=>false
  else
    GGraph.set_map "coast_world"=>false, 'grid'=>false
  end
  GGraph.set_axes('xlabelint'=>30)
  GGraph.set_axes('ylabelint'=>30)

  GGraph.tone    gpout[true,true,iMon], true , 'exchange'=>false,
                 'title'=>vname, 
                 'map_axes'=>true, 'annotate'=>false, 
                 'nlev'=>50, 'keep'=>true, 
                 'min'=>cntmin, 'max'=>cntmax #, 'lev'=>levels, 'pat'=>patterns
#  GGraph.contour gpout[true,true,iMon], false, 'exchange'=>false,
#                 'nlev'=>50, 'keep'=>true
##                 'min'=>cntmin, 'max'=>cntmax #, 'lev'=>levels
  GGraph.color_bar

  if TopogNC.size > 0 then
    url = TopogNC + "@" + TopogName
    gp_topog = GPhys::IO.open_gturl( url )
    GGraph.contour gp_topog, false, 'exchange'=>false, 'lev'=>[0]
  end

  if nMon > 1 then
    title = (iMon+1).to_s + "/" + nMon.to_s
    DCL::uxmttl('T', ' '  , 1.0)
    DCL::uxmttl('T', title, -1.0)
  end
end

DCL.grcls
