require "numru/ggraph"
require 'getoptlong'
include NumRu
require "./gp_dcpam_const_v1.0"
require "./gp_dcpam_methods_v1.0"


parser = GetoptLong.new

parser.set_options(
  ['--meantype',                 GetoptLong::REQUIRED_ARGUMENT],
)

begin
  parser.each_option do |name, arg|
    eval "$OPT_#{name.sub(/^--/, '').gsub(/-/, '_')} = '#{arg}'"
#    print name, ":", arg, "\n"
  end
rescue
  exit(1)
end

meantype = ($OPT_meantype||"year").to_s


DaysInAYear = DaysOfMonth.sum


if ARGV.size == 3 then
  path     = ARGV[1]
  vname    = ARGV[2]
else
  print "Unexpected number of arguments: ", ARGV.size, "\n"
  exit
end


ncfn = path
url = ncfn + "@" + vname
gphys = GPhys::IO.open_gturl( url )


na_time_in = gphys.coord('time').val

case meantype
when "year" then
  a_meanwidth = [ DaysInAYear * DataNumOfDay ]
when "month" then
  a_meanwidth = Array.new( DaysOfMonth.size )
  DaysOfMonth.each_with_index do |nDays, index|
    a_meanwidth[index] = nDays * DataNumOfDay
  end
end
nMon = a_meanwidth.length

ts = - DaysInAYear * DataNumOfDay
te = -1
gpout = time_interval_mean( gphys[true,true,ts..te], a_meanwidth )


iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i
DCL.gropn(iws)

#DCL.sldiv('y',1,4)
DCL.sgpset('isub', 96)     # control character of subscription: '_' --> '`'
DCL.sgpset('lfull',true)
DCL.uzfact(0.6)            # font size
DCL.sgpset('lclip', true)  # clip graph
DCL.glpset('lmiss',true)   # missing value

#DCL.sgscmn(4)  # blue-cyan-white-yellow-red
#DCL.sgscmn(5)  # gray-scale
#DCL.sgscmn(14) # blue-white-red

#levels = [110,120,130,140,150,160,170,180,190,200,210,220,230,240]
#patterns = [10999,15999,20999,25999,30999,35999,40999,50999,60999,65999,70999,75999,80999,90999,95999]


cntmin = gpout.min
cntmax = gpout.max
for iMon in 0..(nMon-1)

  GGraph.set_fig 'itr'=> 10, 'viewport'=>[0.1,0.9,0.2,0.6], 'window'=>[0,360,-90,90]
  if PlanetName == "Earth" then
    GGraph.set_map "coast_world"=>true, 'grid'=>false
  else
    GGraph.set_map "coast_world"=>false, 'grid'=>false
  end
  GGraph.set_axes('xlabelint'=>30)
  GGraph.set_axes('ylabelint'=>30)

  GGraph.tone    gpout[true,true,iMon], true , 'exchange'=>false,
                 'map_axes'=>true, 'annotate'=>false,
                 'nlev'=>50, 'keep'=>true, 
                 'min'=>cntmin, 'max'=>cntmax #, 'lev'=>levels, 'pat'=>patterns
#  GGraph.contour gpout[true,true,iMon], false, 'exchange'=>false,
#                 'nlev'=>50, 'keep'=>true, 
#                 'min'=>cntmin, 'max'=>cntmax #, 'lev'=>levels
  GGraph.color_bar

  if TopogNC.size > 0 then
    url = TopogNC + "@" + TopogName
    gp_topog = GPhys::IO.open_gturl( url )
    GGraph.contour gp_topog, false, 'exchange'=>false, 'lev'=>[0]
  end

  if nMon > 1 then
    title = (iMon+1).to_s + "/" + nMon.to_s
    DCL::uxmttl('T', ' '  , 1.0)
    DCL::uxmttl('T', title, -1.0)
  end
end

DCL.grcls
