require "numru/ggraph"
require "./gp_dcpam_const_v1.0"
require "./gp_dcpam_methods_v1.0"
include NumRu

DaysInAYear = DaysOfMonth.sum


if ARGV.size == 2 then
  pardir = ARGV[1]
else
  print "Unexpected number of arguments: ", ARGV.size, "\n"
  exit
end

vnames = ["OLRA", "OSRA", "SLRA", "SSRA", "SensA", "EvapU"]
signs  = ["TOA" , "TOA" , "Sfc" , "Sfc" , "Sfc"  , "Sfc"  ]

for ivar in 0..(vnames.size-1)
  vname = vnames[ivar]
  case signs[ivar]
  when "TOA" then
    pn = -1
  else
    pn =  1
  end
  ncfn = pardir+"/"+vname+"_rank??????.nc"
  url = ncfn + "@" + vname
  gphys = GPhys::IO.open_gturl( url )

  if ivar == 0 then
    gpout = gphys[0,true,0].copy
    gpout[true] = 0.0

    na_time_in = gphys.coord('time').val
    ntime = na_time_in.size
    times = na_time_in[-DaysInAYear*DataNumOfDay]
    timee = na_time_in[-1]

    gm = 0.0
  end
#  gpout = gpout + gphys.cut('time'=>times..timee).mean('time').mean('lon') * pn
#  gpout = gpout + gphys.cut('time'=>times..timee).mean('time') * pn
  gp_each = ( gphys.cut('time'=>times..timee).mean('time') * pn ).copy
  gpout = gpout + gp_each

  gm_each = calc_gm( gp_each )
  gm += gm_each
  print vname, " : ", gm_each * pn, "\n"
end

gpout = gpout.mean('lon')
gpout = meridional_heat_flux( gpout )
gpout *= RPlanet**2

print "Output for check\n"
print "  Flux convergence\n"
print "    Meridional direction : ", - ( gpout[-1].val - gpout[0].val ) / (4*PI*RPlanet**2), " W m-2","\n"
print "    Vertical direction   : ", gm.val, " W m-2","\n"

iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i
DCL.gropn(iws)

#DCL.sldiv('y',1,4)
DCL.sgpset('isub', 96)     # control character of subscription: '_' --> '`'
DCL.sgpset('lfull',true)
DCL.uzfact(0.6)            # font size
DCL.sgpset('lclip', true)  # clip graph
DCL.glpset('lmiss',true)   # missing value

#DCL.sgscmn(4)  # blue-cyan-white-yellow-red
#DCL.sgscmn(5)  # gray-scale
#DCL.sgscmn(14) # blue-white-red

#levels = [110,120,130,140,150,160,170,180,190,200,210,220,230,240]
#patterns = [10999,15999,20999,25999,30999,35999,40999,50999,60999,65999,70999,75999,80999,90999,95999]

GGraph.set_axes('xlabelint'=>30)
GGraph.set_fig 'itr'=> 1, 'viewport'=>[0.1,0.9,0.1,0.6]#, 'window'=>[-90,90,???,???]

GGraph.line gpout, true , 'exchange'=>false#, 'min'=>cntmin, 'max'=>cntmax

DCL.grcls
